diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/bindings/modulegen__gcc_LP64.py ns-3.34/src/olsr/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/olsr/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
@@ -113,6 +113,8 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress [class]
     module.add_class('Ipv4InterfaceAddress', import_from_module='ns.internet')
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e [enumeration]
@@ -125,6 +127,8 @@
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -683,10 +687,12 @@
     register_Ns3IntToType__5_methods(root_module, root_module['ns3::IntToType< 5 >'])
     register_Ns3IntToType__6_methods(root_module, root_module['ns3::IntToType< 6 >'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4InterfaceAddress_methods(root_module, root_module['ns3::Ipv4InterfaceAddress'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv4RoutingHelper_methods(root_module, root_module['ns3::Ipv4RoutingHelper'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1789,6 +1795,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4InterfaceAddress_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2120,6 +2138,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -2195,6 +2218,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2215,6 +2250,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -2623,8 +2663,8 @@
 def register_Ns3OlsrHelper_methods(root_module, cls):
     ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper::OlsrHelper() [constructor]
     cls.add_constructor([])
-    ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper::OlsrHelper(ns3::OlsrHelper const & arg0) [constructor]
-    cls.add_constructor([param('ns3::OlsrHelper const &', 'arg0')])
+    ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper::OlsrHelper(ns3::OlsrHelper const & o) [constructor]
+    cls.add_constructor([param('ns3::OlsrHelper const &', 'o')])
     ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper * ns3::OlsrHelper::Copy() const [member function]
     cls.add_method('Copy', 
                    'ns3::OlsrHelper *', 
@@ -4426,10 +4466,10 @@
     cls.add_method('SetPriority', 
                    'void', 
                    [param('uint8_t', 'priority')])
-    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> arg0) [member function]
+    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> receivedData) [member function]
     cls.add_method('SetRecvCallback', 
                    'void', 
-                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'arg0')])
+                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'receivedData')])
     ## socket.h (module 'network'): void ns3::Socket::SetRecvPktInfo(bool flag) [member function]
     cls.add_method('SetRecvPktInfo', 
                    'void', 
@@ -8158,7 +8198,7 @@
     cls.add_method('GetIpv4', 
                    'ns3::Ptr< ns3::Ipv4 >', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   deprecated=True, is_const=True, is_virtual=True)
     ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::PrintRoutingTable(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
     cls.add_method('PrintRoutingTable', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/examples/olsr-hna.cc ns-3.34/src/olsr/examples/olsr-hna.cc
--- ns-3.33/src/olsr/examples/olsr-hna.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/examples/olsr-hna.cc	2021-07-14 10:31:07.000000000 -0700
@@ -251,6 +251,9 @@
   // Tracing
   wifiPhy.EnablePcap ("olsr-hna", devices);
   csma.EnablePcap ("olsr-hna", csmaDevices, false);
+  AsciiTraceHelper ascii;
+  wifiPhy.EnableAsciiAll (ascii.CreateFileStream ("olsr-hna-wifi.tr"));
+  csma.EnableAsciiAll (ascii.CreateFileStream ("olsr-hna-csma.tr"));
 
   Simulator::ScheduleWithContext (source->GetNode ()->GetId (),
                                   Seconds (15.0), &GenerateTraffic,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/helper/olsr-helper.h ns-3.34/src/olsr/helper/olsr-helper.h
--- ns-3.33/src/olsr/helper/olsr-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/helper/olsr-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -49,8 +49,10 @@
   /**
    * \brief Construct an OlsrHelper from another previously initialized instance
    * (Copy Constructor).
+   *
+   * \param o object to copy
    */
-  OlsrHelper (const OlsrHelper &);
+  OlsrHelper (const OlsrHelper &o);
 
   /**
    * \returns pointer to clone of this OlsrHelper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/model/olsr-header.cc ns-3.34/src/olsr/model/olsr-header.cc
--- ns-3.33/src/olsr/model/olsr-header.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/model/olsr-header.cc	2021-07-14 10:31:07.000000000 -0700
@@ -135,7 +135,7 @@
 void
 PacketHeader::Print (std::ostream &os) const
 {
-  /// \todo
+  os << "len: " << m_packetLength	<< " seqNo: " << m_packetSequenceNumber;
 }
 
 void
@@ -213,7 +213,46 @@
 void
 MessageHeader::Print (std::ostream &os) const
 {
-  /// \todo
+  switch (m_messageType)
+  {
+    case HELLO_MESSAGE:
+      os << "type: HELLO";
+      break;
+    case TC_MESSAGE:
+      os << "type: TC";
+      break;
+    case MID_MESSAGE:
+      os << "type: MID";
+      break;
+    case HNA_MESSAGE:
+      os << "type: HNA";
+      break;
+  }
+
+  os << " TTL: " << +m_timeToLive;
+  os << " Orig: " << m_originatorAddress;
+  os << " SeqNo: " << m_messageSequenceNumber;
+  os << " Validity: " << +m_vTime;
+  os << " Hop count: " << +m_hopCount;
+  os << " Size: " << m_messageSize;
+
+  switch (m_messageType)
+    {
+    case MID_MESSAGE:
+      m_message.mid.Print (os);
+      break;
+    case HELLO_MESSAGE:
+      m_message.hello.Print (os);
+      break;
+    case TC_MESSAGE:
+      m_message.tc.Print (os);
+      break;
+    case HNA_MESSAGE:
+      m_message.hna.Print (os);
+      break;
+    default:
+      NS_ASSERT (false);
+    }
 }
 
 void
@@ -294,7 +333,21 @@
 void
 MessageHeader::Mid::Print (std::ostream &os) const
 {
-  /// \todo
+  bool first = true;
+  os << " [";
+  for (const auto& iAddr : interfaceAddresses)
+    {
+      if (first)
+        {
+          first = false;
+        }
+      else
+        {
+          os << ", ";
+        }
+      os << iAddr;
+    }
+  os << "]";
 }
 
 void
@@ -348,7 +401,30 @@
 void
 MessageHeader::Hello::Print (std::ostream &os) const
 {
-  /// \todo
+  os << " Interval: " << +hTime << " (" << EmfToSeconds (hTime) << "s)";
+  os << " Willingness: " << +willingness;
+
+  for (const auto& ilinkMessage : linkMessages)
+  	{
+  	  const LinkMessage &lm = ilinkMessage;
+  	  os << " Link code: " << +(lm.linkCode);
+  	  os << " [";
+  	  bool first = true;
+  	  for (const auto& neigh_iter : lm.neighborInterfaceAddresses)
+  	    {
+  	      if (first)
+  	        {
+  	          first = false;
+  	        }
+  	      else
+  	        {
+  	          os << ", ";
+  	        }
+  	      os << neigh_iter;
+  	    }
+      os << "]";
+  	}
+
 }
 
 void
@@ -431,7 +507,22 @@
 void
 MessageHeader::Tc::Print (std::ostream &os) const
 {
-  /// \todo
+  os << " Adv. SeqNo: " << ansn;
+  os << " [";
+  bool first = true;
+  for (const auto& iAddr : neighborAddresses)
+    {
+      if (first)
+        {
+          first = false;
+        }
+      else
+        {
+          os << ", ";
+        }
+      os << iAddr;
+    }
+  os << "]";
 }
 
 void
@@ -483,7 +574,21 @@
 void
 MessageHeader::Hna::Print (std::ostream &os) const
 {
-  /// \todo
+  os << " [";
+  bool first = true;
+  for (const auto& iAssoc : associations)
+  	{
+      if (first)
+        {
+          first = false;
+        }
+      else
+        {
+          os << ", ";
+        }
+  	  os << iAssoc.address << "/" << iAssoc.mask.GetPrefixLength ();
+  	}
+  os << "]";
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/model/olsr-header.h ns-3.34/src/olsr/model/olsr-header.h
--- ns-3.33/src/olsr/model/olsr-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/model/olsr-header.h	2021-07-14 10:31:07.000000000 -0700
@@ -408,7 +408,7 @@
     std::vector<LinkMessage> linkMessages; //!< Link messages container.
 
     /**
-     * This method is used to print the content of a MID message.
+     * This method is used to print the content of a Hello message.
      * \param os output stream
      */
     void Print (std::ostream &os) const;
@@ -461,7 +461,7 @@
     uint16_t ansn;  //!< Advertised Neighbor Sequence Number.
 
     /**
-     * This method is used to print the content of a MID message.
+     * This method is used to print the content of a Tc message.
      * \param os output stream
      */
     void Print (std::ostream &os) const;
@@ -525,7 +525,7 @@
     std::vector<Association> associations; //!< Association container.
 
     /**
-     * This method is used to print the content of a MID message.
+     * This method is used to print the content of a Hna message.
      * \param os output stream
      */
     void Print (std::ostream &os) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/model/olsr-routing-protocol.cc ns-3.34/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.33/src/olsr/model/olsr-routing-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/model/olsr-routing-protocol.cc	2021-07-14 10:31:07.000000000 -0700
@@ -32,6 +32,7 @@
   if (GetObject<Node> ()) { std::clog << "[node " << GetObject<Node> ()->GetId () << "] "; }
 
 
+#include <iomanip>
 #include "olsr-routing-protocol.h"
 #include "ns3/socket-factory.h"
 #include "ns3/udp-socket-factory.h"
@@ -270,41 +271,52 @@
 RoutingProtocol::PrintRoutingTable (Ptr<OutputStreamWrapper> stream, Time::Unit unit) const
 {
   std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now ().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", OLSR Routing table" << std::endl;
 
-  *os << "Destination\t\tNextHop\t\tInterface\tDistance\n";
+  *os << std::setw (16) << "Destination";
+  *os << std::setw (16) << "NextHop";
+  *os << std::setw (16) << "Interface";
+  *os << "Distance" << std::endl;
 
   for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator iter = m_table.begin ();
        iter != m_table.end (); iter++)
     {
-      *os << iter->first << "\t\t";
-      *os << iter->second.nextAddr << "\t\t";
+      *os << std::setw (16) << iter->first;
+      *os << std::setw (16) << iter->second.nextAddr;
+      *os << std::setw (16);
       if (Names::FindName (m_ipv4->GetNetDevice (iter->second.interface)) != "")
         {
-          *os << Names::FindName (m_ipv4->GetNetDevice (iter->second.interface)) << "\t\t";
+          *os << Names::FindName (m_ipv4->GetNetDevice (iter->second.interface));
         }
       else
         {
-          *os << iter->second.interface << "\t\t";
+          *os << iter->second.interface;
         }
-      *os << iter->second.distance << "\t";
-      *os << "\n";
+      *os << iter->second.distance << std::endl;
     }
+  *os << std::endl;
 
   // Also print the HNA routing table
   if (m_hnaRoutingTable->GetNRoutes () > 0)
     {
-      *os << " HNA Routing Table: ";
+      *os << "HNA Routing Table:" << std::endl;
       m_hnaRoutingTable->PrintRoutingTable (stream, unit);
     }
   else
     {
-      *os << " HNA Routing Table: empty" << std::endl;
+      *os << "HNA Routing Table: empty" << std::endl;
     }
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 void RoutingProtocol::DoInitialize ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/model/olsr-routing-protocol.h ns-3.34/src/olsr/model/olsr-routing-protocol.h
--- ns-3.33/src/olsr/model/olsr-routing-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/model/olsr-routing-protocol.h	2021-07-14 10:31:07.000000000 -0700
@@ -351,6 +351,11 @@
                            LocalDeliverCallback lcb,
                            ErrorCallback ecb);
   virtual void SetIpv4 (Ptr<Ipv4> ipv4);
+
+  /**
+   * \returns the ipv4 object this routing protocol is associated with
+   */
+  NS_DEPRECATED_3_34
   virtual Ptr<Ipv4> GetIpv4 (void) const;
   virtual void PrintRoutingTable (Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/openflow/wscript ns-3.34/src/openflow/wscript
--- ns-3.33/src/openflow/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/openflow/wscript	2021-07-14 10:31:07.000000000 -0700
@@ -9,39 +9,7 @@
                    help=('Path to OFSID source for NS-3 OpenFlow Integration support'),
                    default='', dest='with_openflow')
 
-REQUIRED_BOOST_LIBS = ['system', 'signals', 'filesystem']
-
-def required_boost_libs(conf):
-    conf.env['REQUIRED_BOOST_LIBS'] += REQUIRED_BOOST_LIBS
-
 def configure(conf):
-    if not conf.env['LIB_BOOST']:
-        conf.report_optional_feature("openflow", "NS-3 OpenFlow Integration", False,
-                                     "Required boost libraries not found")
-
-        # Add this module to the list of modules that won't be built
-        # if they are enabled.
-        conf.env['MODULES_NOT_BUILT'].append('openflow')
-        return 
-
-    present_boost_libs = []
-    for boost_lib_name in conf.env['LIB_BOOST']:
-        if boost_lib_name.startswith("boost_"):
-            boost_lib_name = boost_lib_name[6:]
-        if boost_lib_name.endswith("-mt"):
-            boost_lib_name = boost_lib_name[:-3]
-        present_boost_libs.append(boost_lib_name)
-
-    missing_boost_libs = [lib for lib in REQUIRED_BOOST_LIBS if lib not in present_boost_libs]
-    if missing_boost_libs != []:
-        conf.report_optional_feature("openflow", "NS-3 OpenFlow Integration", False,
-                                     "Required boost libraries not found, missing: %s" % ', '.join(missing_boost_libs))
-
-        # Add this module to the list of modules that won't be built
-        # if they are enabled.
-        conf.env['MODULES_NOT_BUILT'].append('openflow')
-        return 
-
     if Options.options.with_openflow:
         if os.path.isdir(Options.options.with_openflow):
             conf.msg("Checking for OpenFlow location", ("%s (given)" % Options.options.with_openflow))
@@ -70,6 +38,10 @@
         conf.env['MODULES_NOT_BUILT'].append('openflow')
         return 
 
+    if not conf.require_boost_incs('openflow', 'NS-3 OpenFlow Integration'):
+        conf.env['MODULES_NOT_BUILT'].append('openflow')
+        return 
+
     test_code = '''
 #include "openflow/openflow.h"
 #include "openflow/nicira-ext.h"
@@ -116,29 +88,30 @@
   return 0;
 }
 '''
+    conf.env['HAVE_DL'] = conf.check(mandatory=True, lib='dl', define_name='HAVE_DL', uselib_store='DL')
 
-    conf.env['DL'] = conf.check(mandatory=True, lib='dl', define_name='DL', uselib_store='DL')
-    conf.env['XML2'] = conf.check(mandatory=True, lib='xml2', define_name='XML2', uselib_store='XML2')
-    
-    conf.env.append_value('NS3_MODULE_PATH',os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'build','default')))
+    conf.env.append_value('NS3_MODULE_PATH',os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'build')))
     conf.env.append_value('NS3_MODULE_PATH',os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'lib')))
     
     conf.env['INCLUDES_OPENFLOW'] = [
         os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'include'))]
     conf.env['LIBPATH_OPENFLOW'] = [
-        os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'build','default')),
+        os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'build')),
         os.path.abspath(os.path.join(conf.env['WITH_OPENFLOW'],'lib'))]
     
     conf.env['DEFINES_OPENFLOW'] = ['NS3_OPENFLOW']
 
     conf.env['OPENFLOW'] = conf.check_nonfatal(fragment=test_code, lib='openflow', 
                                                libpath=conf.env['LIBPATH_OPENFLOW'],
-                                               use='OPENFLOW DL XML2')
+                                               use='OPENFLOW DL')
     conf.env.append_value('LIB_OPENFLOW', 'dl')
     conf.report_optional_feature("openflow", "NS-3 OpenFlow Integration",
                                  conf.env['OPENFLOW'], "openflow library not found")
     if conf.env['OPENFLOW']:
         conf.env['ENABLE_OPENFLOW'] = True
+        # Openflow library has some strncpy() usage that can trigger warnings
+        if conf.env['BUILD_PROFILE'] == 'optimized':
+            conf.env.append_value('CXXFLAGS', '-Wno-stringop-truncation')
     else:
         # Add this module to the list of modules that won't be built
         # if they are enabled.
@@ -153,6 +126,7 @@
 
     # Build the Switch module
     obj = bld.create_ns3_module('openflow', ['internet'])
+    obj.use.append('BOOST')
     obj.source = [
         ]
 
@@ -166,9 +140,9 @@
         #   'test/openflow-examples-test-suite.cc',
             ])
     
-    if bld.env['OPENFLOW'] and bld.env['DL'] and bld.env['XML2']:
-        obj.use.extend('OPENFLOW DL XML2'.split())
-        obj_test.use.extend('OPENFLOW DL XML2'.split())
+    if bld.env['OPENFLOW'] and bld.env['HAVE_DL']:
+        obj.use.extend('OPENFLOW DL'.split())
+        obj_test.use.extend('OPENFLOW DL'.split())
 
     headers = bld(features='ns3header')
     headers.module = 'openflow'
